'Graphics Library for o2Basic by Peter Wirbelauer 10.o4.2o18
indexbase 0

! FileExists     Lib "asm.dll" (string FileName) as sys  'if failed, returned value is -1
! FileSize       Lib "asm.dll" (sys FileHandle ) as sys  'returns the size of a file 
! FilePointer    Lib "asm.dll" (sys FileHandle,DistanceToMove) as sys 'moves the file pointer of the specified file.
! OpenFile       Lib "asm.dll" (string FileName) as sys  'returns a handle
! CloseFile      Lib "asm.dll" (sys FileHandle ) as sys  'closes an open file 
! ReadByte       Lib "asm.dll" (sys FileHandle, byref Dest as any, sys bytesToRead ) as sys 'reads  bytes into an array/memory
! ReadWord       Lib "asm.dll" (sys FileHandle, byref dest as any, sys wordsToRead) as sys
! ReadLong       Lib "asm.dll" (sys Filehandle, byref dest as any, sys longToRead) as sys
! WriteByte      Lib "asm.dll" (sys FileHandle, byref dest as any, sys bytesToWrite) as sys 'writes bytes into an array/memory
! WriteWord      Lib "asm.dll" (sys Filehandle, byref souce as any, sys wordsToWrite) as sys 
! WriteLong      Lib "asm.dll" (sys Filehandle, byref souce as any, sys longToWrite) as sys 

! WinEnd         Lib "asm.dll" () as sys                      'ends the application
! DoEvents       Lib "asm.dll" () as sys                      'extern event loop 
! Flip           Lib "asm.dll" () as sys                      'swaps backbuffer to frontbuffer 
! Redraw         Lib "asm.dll" () as sys                      'swaps backbuffer to frontbuffer 
! SetFrames      Lib "asm.dll" (sys frames) as sys            'sets the framerate, default is 60 fps
! GetFrames      Lib "asm.dll" () as sys                      'returns framerate
! Window         Lib "asm.dll" (sys width,height,mode) as sys 'mode 1=windowed, mode 0=fullscreen  
! WinText        Lib "asm.dll" (string text) as sys           'window title bar
! MsgBox         Lib "asm.dll" (string text) as sys           'small message window
! Cls            Lib "asm.dll" (sys red,green,blue) as sys    'clears the screen with given colour
! ScreenW        Lib "asm.dll" () as sys                      'screen_width
! ScreenH        Lib "asm.dll" () as sys                      'screen_height
! Text           Lib "asm.dll" (sys xpos,ypos,fontsize,string txt) as sys 'draws a text on the screen
! Color          Lib "asm.dll" (sys red,green,blue) as sys    'foregound color, also for all drawing operation
! BackColor      Lib "asm.dll" (sys red,green,blue) as sys    'only for text

! Key            Lib "asm.dll" (sys keycode) as short  'keypress 
! KeyDown        Lib "asm.dll" (sys keycode) as short  'keypress 
! WaitKey        Lib "asm.dll" () as sys               'waits for keystroke
! GetAsc         Lib "asm.dll" () as sys               'ascii signs
! GetChar        Lib "asm.dll" () as string            'string sign 

! Wait           Lib "asm.dll" (sys msecs) as sys      'waits some milliseconds
! Rnd            Lib "asm.dll" (sys number) as sys     '32bit random number
! Rand           Lib "asm.dll" (sys min,max) as sys    '32bit random number
! Randomize      Lib "asm.dll" () as sys               'init random start value, not necessary, asm does it for you  
! GetBufferDC    Lib "asm.dll" () as sys               'returns backbuffer address 
! GetHwnd        Lib "asm.dll" () as sys               'returns window handle  
! ColorKey       Lib "asm.dll" (sys r, g, b) as sys    'color mask for sprites, standard is black

! LoadImage      Lib "asm.dll" (string bmpfile,sys frames) as sys       'returns an identification number [1-1024]
! Image          Lib "asm.dll" (sys id,xpos,ypos) as sys                'draws an image 
! DrawImage      Lib "asm.dll" (sys id,xpos,ypos,frame) as sys          'draws an image 
! ScaleImage     Lib "asm.dll" (sys id,x1,y1,width,height,frame) as sys 'scales an image
! BlendImage     Lib "asm.dll" (sys id,xpos,ypos,width,height,alpha) as sys 'alpha = 0-255 
! RotateImage    Lib "asm.dll" (sys id,xpos,ypos, single size,angle) as sys 'angle = 0-360
! FreeImage      Lib "asm.dll" (sys id) as sys                 'only if you want, otherwise Asm does it for you.
! SetImagePixel  Lib "asm.dll" (sys id,x,y, col) as sys        'sets a pixel into an image 
! GetImagePixel  Lib "asm.dll" (sys id,x,y) as sys             'fetches a pixel from an image
! ImageH         Lib "asm.dll" (sys id) as sys                 'image height
! ImageW         Lib "asm.dll" (sys id) as sys                 'image width
! CreateImage    Lib "asm.dll" (sys width,height) as sys       'create a new image
! DrawImageRect  Lib "asm.dll" (sys xscr,yscr,width,height,ximage,yimage) as sys 'draws a portion of the image without tranzparents
! UseImage       Lib "asm.dll" (sys switch) as sys             'if switch=on, we write all in the CREATEIMAGE image, all IMAGE commands and TILE commands!  

! LoadTile       Lib "asm.dll" (string bmpfile, sys xframe,yframe) as sys
! DrawTile       Lib "asm.dll" (sys index,xpos,ypos,xframe,yframe) as sys
! ScaleTile      Lib "asm.dll" (sys index,xpos,ypos,xzoom,yzoom,xframe,yframe) as sys
! FreeTile       Lib "asm.dll" (sys index) as sys   'only if you want, otherwise Asm does it for you. 
! TileText       Lib "asm.dll" (sys index,xpos,ypos,string txt,sys xzoom,yzoom) as sys 'draws a bitmap text; the bitmap must be a tile 

! LoadIcon       Lib "asm.dll" (string iconFile) as sys  ' iconfile = name.ico or name.ani   
! ScaleIcon      Lib "asm.dll" (sys icoID,xpos,ypos,xzoom,yzoom,frames) as sys 'scales an icon
! IconText       Lib "asm.dll" (sys icoID,xpos,ypos, string txt, sys xzoom,yzoom) as sys 'sets an icon text from an icon strips, format is: name.ani
! DrawIcon       Lib "asm.dll" (sys icoID,xpos,ypos,frame) as sys   'draws an icon

! Circle         Lib "asm.dll" (sys xpos,ypos,r1) as sys                 'draws a circle   
! FillCircle     Lib "asm.dll" (sys xpos,ypos,r1) as sys                 'draws a filled circle 
! FillEllipse    Lib "asm.dll" (sys xpos,ypos,r1,r2) as sys              'draws a filled ellipse                
! Ellipse        Lib "asm.dll" (sys xpos,ypos,r1,r2) as sys              'draws an ellipse
! Box            Lib "asm.dll" (sys xpos,ypos,width,height) as sys       'draws a rectangle
! FillBox        Lib "asm.dll" (sys xpos,ypos,width,height) as sys       'draws a filled rectangle 
! Line           Lib "asm.dll" (sys xpos,ypos,width,height) as sys       'draws a line  
! LineSize       Lib "asm.dll" (sys lsize) as sys                        'sets the width of a line
! LineRGB        Lib "asm.dll" (sys xpos,ypos,width,height,color) as sys 'draws a line with complete colour
! FloodFill      Lib "asm.dll" (sys xpos,ypos,oldcolor,newcolor) as sys  'fills a shape with new colour
! RoundBox       Lib "asm.dll" (sys x,y,w,h,r1,r2) as sys                'draws a round rectangle 
! FillRoundBox   Lib "asm.dll" (sys x,y,w,h,r1,r2) as sys                'draws a filled round rectangle 
! DrawPoint      Lib "asm.dll" (sys xpos,ypos,size) as sys               'draws a colour pixel in various sizes
! PutPoint       Lib "asm.dll" (sys xpos,ypos,size,color) as sys         'draws a colour pixel in various sizes with colour
! PutPixel       Lib "asm.dll" (sys xpos,ypos,color) as sys              'draws a colour pixel               
! SetPixel       Lib "asm.dll" (sys xpos,ypos) as sys                    'draws a colour pixel, needed color(r,g,b) command 
! GetPixel       Lib "asm.dll" (sys xpos,ypos) as sys                    'returns the colour of a pixel     
! aPixel         Lib "asm.dll" (sys xpos,ypos, single alpha) as sys      'draws an alpha pixel, alpha value can be: 0.0 - 1.0
! BoxColl        Lib "asm.dll" (sys xpos1,ypos1,width1,height1,xpos2,ypos2,width2,height2) as sys 'shapes have a rectangle around their shape, is a rectangle collision
! CirleColl      Lib "asm.dll" (sys xpos1,ypos1 radius1,xpos2,ypos2,radius2) as sys               'shapes have a circle around their shape,    is a circle collision 
! GetR           Lib "asm.dll" (sys color) as sys                        'red   component
! GetG           Lib "asm.dll" (sys color) as sys                        'green component
! GetB           Lib "asm.dll" (sys color) as sys                        'blue  component
! RGB            Lib "asm.dll" (sys red,green,blue) as sys               'three components colour   

! CenterMousePos Lib "asm.dll" () as sys                                 'centers mouse pointer in the middle of the screen
! yMouse         Lib "asm.dll" () as sys                                 'mouse cusor position in vertical   direction
! xMouse         Lib "asm.dll" () as sys                                 'mouse cusor position in horizontal direction   
! MouseButton    Lib "asm.dll" () as sys                                 'left=1: right=2: middle=3
! WaitMouse      Lib "asm.dll" () as sys                                 'wait for mouse button stroke 
! MouseZone      Lib "asm.dll" (sys xStart,yStart,xEnd,yEnd) as sys      'No formulation for this command at the moment
! ShowMouse      Lib "asm.dll" (sys number) as sys                       'sets the cursor on or off  1=on : 0=off                  

! LoadWav        Lib "asm.dll" (string wavfile) as sys                   'loads a wav file
! PlayWav        Lib "asm.dll" (sys wavID) as sys                        'plays a wav file  

! Poke           Lib "asm.dll" (sys memadr,offset, byte value) as sys    'writes a byte  into the memory
! Poke16         Lib "asm.dll" (sys memadr,offset, word value) as sys    'writes a word  into the memory
! Poke32         Lib "asm.dll" (sys memadr,offset, dword value) as sys   'writes a dword into the memory   
! Peek           Lib "asm.dll" (sys memadr,offset) as byte               'reads  a byte  from the memory  
! Peek16         Lib "asm.dll" (sys memadr,offset) as word               'reads  a word  from the memory   
! Peek32         Lib "asm.dll" (sys memadr,offset) as dword              'reads  a dword from the memory  
! NewMem         Lib "asm.dll" (sys bytes) as dword                      'create new memory, returns a pointer 
! FreeMem        Lib "asm.dll" (sys pointer) as dword                    'frees  new memory

! Min            Lib "asm.dll" (single min1,min2) as single
! Max            Lib "asm.dll" (single max1,max2) as single
! Sgn            Lib "asm.dll" (sys value) as sys
! Constrain      Lib "asm.dll" (single x, min, max) as single

! TimeHour       Lib "asm.dll" () as sys 
! TimeMinute     Lib "asm.dll" () as sys
! TimeSecond     Lib "asm.dll" () as sys
! TimeDay        Lib "asm.dll" () as sys
! TimeMonth      Lib "asm.dll" () as sys
! TimeYear       Lib "asm.dll" () as sys
! DigiTime       Lib "asm.dll" () as string   'complete time, must run in a loop.
! Ticks          Lib "asm.dll" () as sys

'constants
%ON =1
%OFF=0

'keycodes
% VK_BACK     = 0x08
% VK_TAB      = 0x09 
% VK_CLEAR    = 0x0C 
% VK_RETURN   = 0x0D 
% VK_SHIFT    = 0x10 
% VK_CONTROL  = 0x11 
% VK_MENU     = 0x12 
% VK_PAUSE    = 0x13 
% VK_CAPITAL  = 0x14 
% VK_ESCAPE   = 0x1B 
% VK_SPACE    = 0x20 
% VK_PRIOR    = 0x21 
% VK_NEXT     = 0x22 
% VK_END      = 0x23 
% VK_HOME     = 0x24 
% VK_LEFT     = 0x25 
% VK_UP       = 0x26 
% VK_RIGHT    = 0x27 
% VK_DOWN     = 0x28 
% VK_PRINT    = 0x2A 
% VK_SNAPSHOT = 0x2C	 
% VK_INSERT   = 0x2D 
% VK_DELETE   = 0x2E 
% VK_HELP     = 0x2F 

% VK_0 = 0x30 
% VK_1 = 0x31 
% VK_2 = 0x32 
% VK_3 = 0x33 
% VK_4 = 0x34 
% VK_5 = 0x35
% VK_6 = 0H36 
% VK_7 = 0x37 
% VK_8 = 0x38 
% VK_9 = 0x39 
% VK_@ = 0x40
% VK_A = 0x41 
% VK_B = 0x42 
% VK_C = 0x43 
% VK_D = 0x44 
% VK_E = 0H45 
% VK_F = 0x46 
% VK_G = 0x47 
% VK_H = 0x48 
% VK_I = 0x49 
% VK_J = 0x4A 
% VK_K = 0x4B
% VK_L = 0x4C 
% VK_M = 0x4D 
% VK_N = 0x4E 
% VK_O = 0x4F 
% VK_P = 0x50 
% VK_Q = 0x51 
% VK_R = 0x52 
% VK_S = 0x53 
% VK_T = 0x54 
% VK_U = 0x55 
% VK_V = 0x56 
% VK_W = 0x57 
% VK_X = 0x58 
% VK_Y = 0x59 
% VK_Z = 0x5A 

% VK_F1  = 0x70 
% VK_F2  = 0x71 
% VK_F3  = 0x72 
% VK_F4  = 0x73 
% VK_F5  = 0x74 
% VK_F6  = 0x75 
% VK_F7  = 0x76 
% VK_F8  = 0x77 
% VK_F9  = 0x78 
% VK_F10 = 0x79 
% VK_F11 = 0x7A 
% VK_F12 = 0x7B 

% VK_LSHIFT   = 0xA0 
% VK_RSHIFT   = 0xA1 
% VK_LCONTR   = 0xA2	 
% VK_RCONTROL = 0xA3




